;CodeVisionAVR C Compiler V1.24.6 Standard
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Contr.vec"
	.INCLUDE "Contr.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Chip type           : ATmega8
;       3 Program type        : Application
;       4 Clock frequency     : 8,000000 MHz
;       5 Memory model        : Small
;       6 External SRAM size  : 0
;       7 Data Stack size     : 256
;       8 *****************************************************/
;       9 
;      10 #include	<mega8.h>
;      11 #include	"Hw.h"
;      12 
;      13 unsigned char	Ms10Tmr;
;      14 unsigned char	FrontSwitchMajority[4];
_FrontSwitchMajority:
	.BYTE 0x4
;      15 unsigned char	RelayState;
;      16 unsigned char	HwRelayState;
;      17 unsigned char	FrontSwitchState;
;      18 unsigned char	PrevFrontSwitchState;
;      19 unsigned char	DelayValue;
;      20 unsigned char	SecTmr;
;      21 unsigned char	PowUpTmr;
;      22 //
;      23 unsigned char	BitCnt;
;      24 unsigned char	RecByteI;
;      25 unsigned char	RecByte;
;      26 //
;      27 unsigned char	MidiChannel;
_MidiChannel:
	.BYTE 0x1
;      28 unsigned char	MidiProgramm;
_MidiProgramm:
	.BYTE 0x1
;      29 unsigned char	LastReceivedProgramm;
_LastReceivedProgramm:
	.BYTE 0x1
;      30 
;      31 bit	TimFlg;
;      32 bit	prgChangeDetectedBefore;
;      33 bit	SwitchSettingsAltered;
;      34 bit	DataReceived;
;      35 
;      36 // USART Receiver interrupt service routine
;      37 interrupt [USART_RXC] void usart_rx_isr(void)
;      38 {

	.CSEG
_usart_rx_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      39 	unsigned char	inByte;
;      40 
;      41 	inByte = UCSRA;
	ST   -Y,R16
;	inByte -> R16
	IN   R16,11
;      42 	inByte = UDR;
	IN   R16,12
;      43 
;      44 	if ((inByte & 0x80) != 0)
	SBRS R16,7
	RJMP _0x3
;      45 	{	// Command
;      46 		if ((inByte & 0xF0) == 0xC0)
	MOV  R30,R16
	ANDI R30,LOW(0xF0)
	CPI  R30,LOW(0xC0)
	BRNE _0x4
;      47 		{
;      48 			if ((inByte & 0x0F) == MidiChannel)
	MOV  R30,R16
	ANDI R30,LOW(0xF)
	LDS  R26,_MidiChannel
	CP   R30,R26
	BRNE _0x5
;      49 			{
;      50 				prgChangeDetectedBefore = 1;
	SET
	BLD  R2,1
;      51 			}
;      52 		}
_0x5:
;      53 		else
	RJMP _0x6
_0x4:
;      54 		{
;      55 			prgChangeDetectedBefore = 0;
	CLT
	BLD  R2,1
;      56 		}
_0x6:
;      57 	}
;      58 	else
	RJMP _0x7
_0x3:
;      59 	{	// Data
;      60 		if (prgChangeDetectedBefore != 0)
	SBRS R2,1
	RJMP _0x8
;      61 		{
;      62 			prgChangeDetectedBefore = 0;
	CLT
	BLD  R2,1
;      63 			MidiProgramm = (inByte & 0x7F);
	MOV  R30,R16
	ANDI R30,0x7F
	STS  _MidiProgramm,R30
;      64 		}
;      65 	}
_0x8:
_0x7:
;      66 }
	LD   R16,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
;      67 
;      68 // USART Transmitter interrupt service routine
;      69 interrupt [USART_TXC] void usart_tx_isr(void)
;      70 {
_usart_tx_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      71 	UCSRB &= ~0x40;
	CBI  0xA,6
;      72 	TIFR = 0x20;	// Clear ICF1
	LDI  R30,LOW(32)
	OUT  0x38,R30
;      73 	TIMSK |= 0x20;	// On TICIE1
	IN   R30,0x39
	ORI  R30,0x20
	OUT  0x39,R30
;      74 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;      75 
;      76 // Timer 0 overflow interrupt service routine
;      77 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;      78 {	// 2 mS @ 8MHz
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      79 	if (DelayValue != 0)
	TST  R9
	BREQ _0x9
;      80 		DelayValue--;
	DEC  R9
;      81 	if (Ms10Tmr != 0)
_0x9:
	TST  R4
	BREQ _0xA
;      82 		Ms10Tmr--;
	DEC  R4
;      83 	else
	RJMP _0xB
_0xA:
;      84 	{	// 10 mS @ 8MHz
;      85 		Ms10Tmr = 4;
	LDI  R30,LOW(4)
	MOV  R4,R30
;      86 		FrontSwitchMajority[1] = FrontSwitchMajority[2];
	__GETB1MN _FrontSwitchMajority,2
	__PUTB1MN _FrontSwitchMajority,1
;      87 		FrontSwitchMajority[2] = FrontSwitchMajority[3];
	__GETB1MN _FrontSwitchMajority,3
	__PUTB1MN _FrontSwitchMajority,2
;      88 		FrontSwitchMajority[3] = (PINC & 0x3F) ^ 0x3F;
	IN   R30,0x13
	ANDI R30,LOW(0x3F)
	LDI  R26,LOW(63)
	EOR  R30,R26
	__PUTB1MN _FrontSwitchMajority,3
;      89 		FrontSwitchMajority[0] = ((FrontSwitchMajority[2] | FrontSwitchMajority[3]) & FrontSwitchMajority[1])
;      90 			| (FrontSwitchMajority[2] & FrontSwitchMajority[3]);
	__GETB2MN _FrontSwitchMajority,2
	__GETB1MN _FrontSwitchMajority,3
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _FrontSwitchMajority,1
	AND  R30,R26
	PUSH R30
	__GETB2MN _FrontSwitchMajority,2
	__GETB1MN _FrontSwitchMajority,3
	AND  R30,R26
	POP  R26
	OR   R30,R26
	STS  _FrontSwitchMajority,R30
;      91 		MidiChannel = (PIND >> 4) ^ 0x0F;
	IN   R30,0x10
	SWAP R30
	ANDI R30,0xF
	LDI  R26,LOW(15)
	EOR  R30,R26
	STS  _MidiChannel,R30
;      92 		if (SecTmr != 0)
	TST  R10
	BREQ _0xC
;      93 			SecTmr--;
	DEC  R10
;      94 		else
	RJMP _0xD
_0xC:
;      95 		{
;      96 			SecTmr = 99;
	LDI  R30,LOW(99)
	MOV  R10,R30
;      97 			if (PowUpTmr < 254)
	LDI  R30,LOW(254)
	CP   R11,R30
	BRSH _0xE
;      98 				PowUpTmr++;
	INC  R11
;      99 		}
_0xE:
_0xD:
;     100 		TimFlg = 1;
	SET
	BLD  R2,0
;     101 	}
_0xB:
;     102 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
;     103 //TIMSK/TIFR
;     104 //Bit 5  TICIE1
;     105 //Bit 4  OCIE1A
;     106 // Timer 1 input capture interrupt service routine
;     107 interrupt [TIM1_CAPT] void timer1_capt_isr(void)
;     108 {
_timer1_capt_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     109 	OCR1A = ICR1 + 384;
	IN   R30,0x26
	IN   R31,0x26+1
	SUBI R30,LOW(-384)
	SBCI R31,HIGH(-384)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;     110 	BitCnt = 0;
	CLR  R12
;     111 	TIMSK &= ~0x20;	// Off TICIE1
	IN   R30,0x39
	ANDI R30,0xDF
	OUT  0x39,R30
;     112 	TIFR = 0x10;	// Clear OCF1A
	LDI  R30,LOW(16)
	OUT  0x38,R30
;     113 	TIMSK |= 0x10;	// On OCIE1A
	IN   R30,0x39
	ORI  R30,0x10
	OUT  0x39,R30
;     114 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     115 
;     116 // Timer 1 output compare A interrupt service routine
;     117 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;     118 {
_timer1_compa_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     119 	OCR1A += 256;
	IN   R30,0x2A
	IN   R31,0x2A+1
	SUBI R30,LOW(-256)
	SBCI R31,HIGH(-256)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;     120 	BitCnt++;
	INC  R12
;     121 	if (BitCnt < 9)
	LDI  R30,LOW(9)
	CP   R12,R30
	BRSH _0xF
;     122 	{
;     123 		RecByteI = RecByteI >> 1;
	LSR  R13
;     124 		if ((PINB & 0x01) != 0)
	SBIS 0x16,0
	RJMP _0x10
;     125 			RecByteI |= 0x80;
	LDI  R30,LOW(128)
	OR   R13,R30
;     126 	}
_0x10:
;     127 	else
	RJMP _0x11
_0xF:
;     128 	{
;     129 		TIFR = 0x20;	// Clear ICF1
	LDI  R30,LOW(32)
	OUT  0x38,R30
;     130 		TIMSK |= 0x20;	// On TICIE1
	IN   R30,0x39
	ORI  R30,0x20
	OUT  0x39,R30
;     131 		TIMSK &= ~0x10;	// Off OCIE1A
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
;     132 		RecByte = RecByteI;
	MOV  R14,R13
;     133 		DataReceived = 1;
	SET
	BLD  R2,3
;     134 	}
_0x11:
;     135 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     136 
;     137 unsigned char
;     138 EEPROM_read(unsigned short Address)
;     139 {
_EEPROM_read:
;     140 	while(EECR & 0x02)	// Wait for completion of previous write
_0x12:
	SBIC 0x1C,1
;     141 		;
	RJMP _0x12
;     142 	EEAR = Address;	// Set up address register
	LD   R30,Y
	LDD  R31,Y+1
	OUT  0x1E+1,R31
	OUT  0x1E,R30
;     143 	EECR |= 0x01;	// Start eeprom read by writing EERE
	SBI  0x1C,0
;     144 	return EEDR;	// Return data from data register
	IN   R30,0x1D
	ADIW R28,2
	RET
;     145 }
;     146 
;     147 void
;     148 EEPROM_write(unsigned short Address, unsigned char Data)
;     149 {
_EEPROM_write:
;     150 	if (EEPROM_read(Address) == Data)
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _EEPROM_read
	MOV  R26,R30
	LD   R30,Y
	CP   R30,R26
	BRNE _0x15
;     151 	{
;     152 //		NextEeProgReq = 1;
;     153 		return;
	ADIW R28,3
	RET
;     154 	}
;     155 	EEAR = Address;	// Set up address and data registers
_0x15:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x1E+1,R31
	OUT  0x1E,R30
;     156 	EEDR = Data;
	LD   R30,Y
	OUT  0x1D,R30
;     157 	#asm("cli")
	cli
;     158 	EECR |= 0x04;	// Write logical one to EEMWE
	SBI  0x1C,2
;     159 	EECR |= 0x0A;	// Start eeprom write by setting EEWE
	IN   R30,0x1C
	ORI  R30,LOW(0xA)
	OUT  0x1C,R30
;     160 	#asm("sei")
	sei
;     161 }
	ADIW R28,3
	RET
;     162 
;     163 void
;     164 Wdog(void)
;     165 {
_Wdog:
;     166 	#asm("wdr")
	wdr
;     167 }
	RET
;     168 
;     169 void
;     170 Waitms(unsigned char Del)
;     171 {
_Waitms:
;     172 	DelayValue = Del;
	LDD  R9,Y+0
;     173 	while (DelayValue != 0)
_0x16:
	TST  R9
	BREQ _0x18
;     174 	{
;     175 		Wdog();
	RCALL _Wdog
;     176 	}
	RJMP _0x16
_0x18:
;     177 }
	ADIW R28,1
	RET
;     178 
;     179 void
;     180 SetHwRelays(void)
;     181 {
_SetHwRelays:
;     182 	
;     183 	HwRelayState = RelayState | 0x01;
	MOV  R30,R5
	ORI  R30,1
	MOV  R6,R30
;     184 	if (PowUpTmr > 10)
	LDI  R30,LOW(10)
	CP   R30,R11
	BRSH _0x19
;     185 		HwRelayState |= OUT6;
	LDI  R30,LOW(128)
	OR   R6,R30
;     186 	if (PowUpTmr > 15)
_0x19:
	LDI  R30,LOW(15)
	CP   R30,R11
	BRSH _0x1A
;     187 		HwRelayState |= OUT7;
	LDI  R30,LOW(64)
	OR   R6,R30
;     188 	PORTB = HwRelayState;
_0x1A:
	OUT  0x18,R6
;     189 }
	RET
;     190 
;     191 void
;     192 SetRelays(void)
;     193 {
_SetRelays:
;     194 	SetHwRelays();
	RCALL _SetHwRelays
;     195 	UCSRA = 0x40;
	LDI  R30,LOW(64)
	OUT  0xB,R30
;     196 	UCSRB |= 0x40;
	SBI  0xA,6
;     197 	TIMSK &= ~0x20;	// off TICIE1
	IN   R30,0x39
	ANDI R30,0xDF
	OUT  0x39,R30
;     198 	TIMSK &= ~0x10;	// Off OCIE1A
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
;     199 	UDR = HwRelayState;
	OUT  0xC,R6
;     200 }
	RET
;     201 
;     202 void
;     203 SetOut1(void)
;     204 {
_SetOut1:
;     205 	RelayState |= OUT1;
	LDI  R30,LOW(32)
	OR   R5,R30
;     206 	SetHwRelays();
	RCALL _SetHwRelays
;     207 	Waitms(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _Waitms
;     208 	RelayState &= ~(OUT2 | OUT3 | OUT4);
	LDI  R30,LOW(227)
	AND  R5,R30
;     209 	SetRelays();
	RCALL _SetRelays
;     210 	SwitchSettingsAltered = 1;
	SET
	BLD  R2,2
;     211 }
	RET
;     212 
;     213 void
;     214 SetOut2(void)
;     215 {
_SetOut2:
;     216 	RelayState |= OUT2;
	LDI  R30,LOW(16)
	OR   R5,R30
;     217 	SetHwRelays();
	RCALL _SetHwRelays
;     218 	Waitms(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _Waitms
;     219 	RelayState &= ~(OUT1 | OUT3 | OUT4);
	LDI  R30,LOW(211)
	AND  R5,R30
;     220 	SetRelays();
	RCALL _SetRelays
;     221 	SwitchSettingsAltered = 1;
	SET
	BLD  R2,2
;     222 }
	RET
;     223 
;     224 void
;     225 SetOut3(void)
;     226 {
_SetOut3:
;     227 	RelayState |= OUT3;
	LDI  R30,LOW(8)
	OR   R5,R30
;     228 	SetHwRelays();
	RCALL _SetHwRelays
;     229 	Waitms(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _Waitms
;     230 	RelayState &= ~(OUT1 | OUT2 | OUT4);
	LDI  R30,LOW(203)
	AND  R5,R30
;     231 	SetRelays();
	RCALL _SetRelays
;     232 	SwitchSettingsAltered = 1;
	SET
	BLD  R2,2
;     233 }
	RET
;     234 
;     235 void
;     236 SetOut4(void)
;     237 {
_SetOut4:
;     238 	RelayState |= OUT4;
	LDI  R30,LOW(4)
	OR   R5,R30
;     239 	SetHwRelays();
	RCALL _SetHwRelays
;     240 	Waitms(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _Waitms
;     241 	RelayState &= ~(OUT1 | OUT2 | OUT3);
	LDI  R30,LOW(199)
	AND  R5,R30
;     242 	SetRelays();
	RCALL _SetRelays
;     243 	SwitchSettingsAltered = 1;
	SET
	BLD  R2,2
;     244 }
	RET
;     245 
;     246 void
;     247 SetOut5(void)
;     248 {
_SetOut5:
;     249 	RelayState ^= OUT5;
	LDI  R30,LOW(2)
	EOR  R5,R30
;     250 	SetRelays();
	RCALL _SetRelays
;     251 	SwitchSettingsAltered = 1;
	SET
	BLD  R2,2
;     252 }
	RET
;     253 
;     254 void
;     255 NextOut(void)
;     256 {
_NextOut:
;     257 	if ((RelayState & OUT1) != 0)
	SBRS R5,5
	RJMP _0x1B
;     258 		SetOut2();
	RCALL _SetOut2
;     259 	else if ((RelayState & OUT2) != 0)
	RJMP _0x1C
_0x1B:
	SBRS R5,4
	RJMP _0x1D
;     260 		SetOut3();
	RCALL _SetOut3
;     261 	else if ((RelayState & OUT3) != 0)
	RJMP _0x1E
_0x1D:
	SBRS R5,3
	RJMP _0x1F
;     262 		SetOut4();
	RCALL _SetOut4
;     263 	else
	RJMP _0x20
_0x1F:
;     264 		SetOut1();
	RCALL _SetOut1
;     265 }
_0x20:
_0x1E:
_0x1C:
	RET
;     266 
;     267 void
;     268 PrevOut(void)
;     269 {
_PrevOut:
;     270 	if ((RelayState & OUT1) != 0)
	SBRS R5,5
	RJMP _0x21
;     271 		SetOut4();
	RCALL _SetOut4
;     272 	else if ((RelayState & OUT2) != 0)
	RJMP _0x22
_0x21:
	SBRS R5,4
	RJMP _0x23
;     273 		SetOut1();
	RCALL _SetOut1
;     274 	else if ((RelayState & OUT3) != 0)
	RJMP _0x24
_0x23:
	SBRS R5,3
	RJMP _0x25
;     275 		SetOut2();
	RCALL _SetOut2
;     276 	else
	RJMP _0x26
_0x25:
;     277 		SetOut3();
	RCALL _SetOut3
;     278 }
_0x26:
_0x24:
_0x22:
	RET
;     279 
;     280 void
;     281 main(void)
;     282 {
_main:
;     283 	unsigned char	EeValue;
;     284 	
;     285 	InitHw();
;	EeValue -> R16
	RCALL _InitHw
;     286 	TIFR = 0x20;	// Clear ICF1
	LDI  R30,LOW(32)
	OUT  0x38,R30
;     287 	TIMSK |= 0x20;	// On TICIE1
	IN   R30,0x39
	ORI  R30,0x20
	OUT  0x39,R30
;     288 	TIMSK &= ~0x10;	// Off OCIE1A
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
;     289 	PowUpTmr = 0;
	CLR  R11
;     290 	MidiProgramm = 255;
	LDI  R30,LOW(255)
	STS  _MidiProgramm,R30
;     291 	RelayState = OUT1;
	LDI  R30,LOW(32)
	MOV  R5,R30
;     292 	// Global enable interrupts
;     293 	#asm("sei")
	sei
;     294 	Waitms(255);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _Waitms
;     295 	SetRelays();
	RCALL _SetRelays
;     296 	//
;     297 	while (1)
_0x27:
;     298 	{
;     299 		Wdog();
	RCALL _Wdog
;     300 		if (TimFlg == 1)
	SBRS R2,0
	RJMP _0x2A
;     301 		{
;     302 			TimFlg = 0;
	CLT
	BLD  R2,0
;     303 			SetHwRelays();
	RCALL _SetHwRelays
;     304 			PrevFrontSwitchState = FrontSwitchState;
	MOV  R8,R7
;     305 			FrontSwitchState = FrontSwitchMajority[0];
	LDS  R7,_FrontSwitchMajority
;     306 			if (((FrontSwitchState & IN1) != 0) &&
;     307 				((PrevFrontSwitchState & IN1) == 0))
	SBRS R7,0
	RJMP _0x2C
	SBRS R8,0
	RJMP _0x2D
_0x2C:
	RJMP _0x2B
_0x2D:
;     308 			{
;     309 				NextOut();
	RCALL _NextOut
;     310 			}
;     311 			if (((FrontSwitchState & IN2) != 0) &&
_0x2B:
;     312 				((PrevFrontSwitchState & IN2) == 0))
	SBRS R7,1
	RJMP _0x2F
	SBRS R8,1
	RJMP _0x30
_0x2F:
	RJMP _0x2E
_0x30:
;     313 			{
;     314 				PrevOut();
	RCALL _PrevOut
;     315 			}
;     316 			if (((FrontSwitchState & IN3) != 0) &&
_0x2E:
;     317 				((PrevFrontSwitchState & IN3) == 0))
	SBRS R7,2
	RJMP _0x32
	SBRS R8,2
_0x32:
;     318 			{
;     319 				//SetOut3();
;     320 			}
;     321 			if (((FrontSwitchState & IN4) != 0) &&
;     322 				((PrevFrontSwitchState & IN4) == 0))
	SBRS R7,3
	RJMP _0x35
	SBRS R8,3
_0x35:
;     323 			{
;     324 				//SetOut4();
;     325 			}
;     326 			if (((FrontSwitchState & IN5) != 0) &&
;     327 				((PrevFrontSwitchState & IN5) == 0))
	SBRS R7,4
	RJMP _0x38
	SBRS R8,4
	RJMP _0x39
_0x38:
	RJMP _0x37
_0x39:
;     328 			{
;     329 				SetOut5();
	RCALL _SetOut5
;     330 			}
;     331 		}
_0x37:
;     332 		if (DataReceived)
_0x2A:
	SBRS R2,3
	RJMP _0x3A
;     333 		{
;     334 			DataReceived = 0;
	CLT
	BLD  R2,3
;     335 			if ((RecByte & IN1) != 0)
	SBRC R14,0
;     336 				SetOut1();
	RCALL _SetOut1
;     337 			if ((RecByte & IN2) != 0)
	SBRC R14,1
;     338 				SetOut2();
	RCALL _SetOut2
;     339 			if ((RecByte & IN3) != 0)
	SBRC R14,2
;     340 				SetOut3();
	RCALL _SetOut3
;     341 			if ((RecByte & IN4) != 0)
	SBRC R14,3
;     342 				SetOut4();
	RCALL _SetOut4
;     343 			if ((RecByte & IN5) != 0)
	SBRC R14,4
;     344 				SetOut5();
	RCALL _SetOut5
;     345 		}
;     346 		if (MidiProgramm != 255)
_0x3A:
	LDS  R26,_MidiProgramm
	CPI  R26,LOW(0xFF)
	BREQ _0x40
;     347 		{
;     348 			if (MidiProgramm == LastReceivedProgramm &&
;     349 				 SwitchSettingsAltered != 0)
	LDS  R30,_LastReceivedProgramm
	CP   R30,R26
	BRNE _0x42
	SBRC R2,2
	RJMP _0x43
_0x42:
	RJMP _0x41
_0x43:
;     350 			{
;     351 				if ((FrontSwitchState & IN6) == 0/*!= 0*/)
	SBRC R7,5
	RJMP _0x44
;     352 					EEPROM_write(MidiProgramm, RelayState);
	LDS  R30,_MidiProgramm
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R5
	RCALL _EEPROM_write
;     353 			}
_0x44:
;     354 			else
	RJMP _0x45
_0x41:
;     355 			{
;     356 				EeValue =  EEPROM_read(MidiProgramm);
	LDS  R30,_MidiProgramm
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _EEPROM_read
	MOV  R16,R30
;     357 				if ((EeValue & ~(OUT1 | OUT2 | OUT3 | OUT4 | OUT5)) == 0)
	MOV  R30,R16
	ANDI R30,LOW(0xC1)
	BRNE _0x46
;     358 				{
;     359 					RelayState = EeValue;
	MOV  R5,R16
;     360 					SetRelays();
	RCALL _SetRelays
;     361 				}
;     362 			}
_0x46:
_0x45:
;     363 			LastReceivedProgramm = MidiProgramm;
	LDS  R30,_MidiProgramm
	STS  _LastReceivedProgramm,R30
;     364 			SwitchSettingsAltered = 0;
	CLT
	BLD  R2,2
;     365 			MidiProgramm = 255;
	LDI  R30,LOW(255)
	STS  _MidiProgramm,R30
;     366 		}	
;     367 	}
_0x40:
	RJMP _0x27
;     368 }
_0x47:
	RJMP _0x47
;     369 #include <mega8.h>
;     370 
;     371 void
;     372 InitHw(void)
;     373 {
_InitHw:
;     374 	// Input/Output Ports initialization
;     375 	// Port B initialization
;     376 	// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In 
;     377 	// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=P 
;     378 	PORTB = 0x01;
	LDI  R30,LOW(1)
	OUT  0x18,R30
;     379 	DDRB = 0xFE;
	LDI  R30,LOW(254)
	OUT  0x17,R30
;     380 	// Port C initialization
;     381 	// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     382 	// State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
;     383 	PORTC = 0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     384 	DDRC = 0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
;     385 	// Port D initialization
;     386 	// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
;     387 	// State7=P State6=P State5=P State4=P State3=1 State2=1 State1=1 State0=P 
;     388 	PORTD = 0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     389 	DDRD = 0x0E;
	LDI  R30,LOW(14)
	OUT  0x11,R30
;     390 	// Timer/Counter 0 initialization
;     391 	// Clock source: System Clock
;     392 	// Clock value: 125,000 kHz
;     393 	TCCR0 = 0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     394 	TCNT0 = 0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     395 	// Timer/Counter 1 initialization
;     396 	// Clock source: System Clock
;     397 	// Clock value: 8000,000 kHz
;     398 	// Mode: Normal top=FFFFh
;     399 	// OC1A output: Discon.
;     400 	// OC1B output: Discon.
;     401 	// Noise Canceler: Off
;     402 	// Input Capture on Falling Edge
;     403 	// Timer 1 Overflow Interrupt: Off
;     404 	// Input Capture Interrupt: On
;     405 	// Compare A Match Interrupt: On
;     406 	// Compare B Match Interrupt: Off
;     407 	TCCR1A = 0x00;
	OUT  0x2F,R30
;     408 	TCCR1B = 0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
;     409 	TCNT1H = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     410 	TCNT1L = 0x00;
	OUT  0x2C,R30
;     411 	ICR1H = 0x00;
	OUT  0x27,R30
;     412 	ICR1L = 0x00;
	OUT  0x26,R30
;     413 	OCR1AH = 0x00;
	OUT  0x2B,R30
;     414 	OCR1AL = 0x00;
	OUT  0x2A,R30
;     415 	OCR1BH = 0x00;
	OUT  0x29,R30
;     416 	OCR1BL = 0x00;
	OUT  0x28,R30
;     417 	// Timer/Counter 2 initialization
;     418 	// Clock source: System Clock
;     419 	// Clock value: Timer 2 Stopped
;     420 	// Mode: Normal top=FFh
;     421 	// OC2 output: Disconnected
;     422 	ASSR = 0x00;
	OUT  0x22,R30
;     423 	TCCR2 = 0x00;
	OUT  0x25,R30
;     424 	TCNT2 = 0x00;
	OUT  0x24,R30
;     425 	OCR2 = 0x00;
	OUT  0x23,R30
;     426 	// External Interrupt(s) initialization
;     427 	// INT0: Off
;     428 	// INT1: Off
;     429 	MCUCR = 0x00;
	OUT  0x35,R30
;     430 	// Timer(s)/Counter(s) Interrupt(s) initialization
;     431 	TIMSK=0x31;
	LDI  R30,LOW(49)
	OUT  0x39,R30
;     432 	// USART initialization
;     433 	// Communication Parameters: 8 Data, 1 Stop, No Parity
;     434 	// USART Receiver: On
;     435 	// USART Transmitter: On
;     436 	// USART Mode: Asynchronous
;     437 	// USART Baud rate: 31250
;     438 	UCSRA = 0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     439 	UCSRB = 0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     440 	UCSRC = 0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     441 	UBRRH = 0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     442 	UBRRL = 0x0F;
	LDI  R30,LOW(15)
	OUT  0x9,R30
;     443 	// Analog Comparator initialization
;     444 	// Analog Comparator: Off
;     445 	// Analog Comparator Input Capture by Timer/Counter 1: Off
;     446 	ACSR = 0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     447 	SFIOR = 0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     448 	// Watchdog Timer initialization
;     449 	// Watchdog Timer Prescaler: OSC/2048k
;     450 #pragma optsize-
;     451 	WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
;     452 	WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
;     453 #ifdef _OPTIMIZE_SIZE_
;     454 #pragma optsize+
;     455 #endif
;     456 }
	RET


;END OF CODE MARKER
__END_OF_CODE:
