
;CodeVisionAVR C Compiler V2.04.2c Standard
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Ms10Tmr=R5
	.DEF _RelayState=R4
	.DEF _HwRelayState=R7
	.DEF _FrontSwitchState=R6
	.DEF _PrevFrontSwitchState=R9
	.DEF _DelayValue=R8
	.DEF _SecTmr=R11
	.DEF _PowUpTmr=R10
	.DEF _BitCnt=R13
	.DEF _RecByteI=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_capt_isr
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP _usart_rx_isr
	RJMP 0x00
	RJMP _usart_tx_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;Chip type           : ATmega8
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 256
;*****************************************************/
;
;#include	<mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include	"Hw.h"
;
;unsigned char	Ms10Tmr;
;unsigned char	FrontSwitchMajority[4];
;unsigned char	RelayState;
;unsigned char	HwRelayState;
;unsigned char	FrontSwitchState;
;unsigned char	PrevFrontSwitchState;
;unsigned char	DelayValue;
;unsigned char	SecTmr;
;unsigned char	PowUpTmr;
;//
;unsigned char	BitCnt;
;unsigned char	RecByteI;
;unsigned char	RecByte;
;//
;unsigned char	MidiChannel;
;unsigned char	MidiProgramm;
;unsigned char	LastReceivedProgramm;
;
;bit	TimFlg;
;bit	prgChangeDetectedBefore;
;bit	SwitchSettingsAltered;
;bit	DataReceived;
;
;// USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 0026 {

	.CSEG
_usart_rx_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0027 	unsigned char	inByte;
; 0000 0028 
; 0000 0029 	inByte = UCSRA;
	ST   -Y,R17
;	inByte -> R17
	IN   R17,11
; 0000 002A 	inByte = UDR;
	IN   R17,12
; 0000 002B 
; 0000 002C 	if ((inByte & 0x80) != 0)
	SBRS R17,7
	RJMP _0x3
; 0000 002D 	{	// Command
; 0000 002E 		if ((inByte & 0xF0) == 0xC0)
	MOV  R30,R17
	ANDI R30,LOW(0xF0)
	CPI  R30,LOW(0xC0)
	BRNE _0x4
; 0000 002F 		{
; 0000 0030 			if ((inByte & 0x0F) == MidiChannel)
	MOV  R30,R17
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	LDS  R30,_MidiChannel
	CP   R30,R26
	BRNE _0x5
; 0000 0031 			{
; 0000 0032 				prgChangeDetectedBefore = 1;
	SET
	BLD  R2,1
; 0000 0033 			}
; 0000 0034 		}
_0x5:
; 0000 0035 		else
	RJMP _0x6
_0x4:
; 0000 0036 		{
; 0000 0037 			prgChangeDetectedBefore = 0;
	CLT
	BLD  R2,1
; 0000 0038 		}
_0x6:
; 0000 0039 	}
; 0000 003A 	else
	RJMP _0x7
_0x3:
; 0000 003B 	{	// Data
; 0000 003C 		if (prgChangeDetectedBefore != 0)
	SBRS R2,1
	RJMP _0x8
; 0000 003D 		{
; 0000 003E 			prgChangeDetectedBefore = 0;
	CLT
	BLD  R2,1
; 0000 003F 			MidiProgramm = (inByte & 0x7F);
	MOV  R30,R17
	ANDI R30,0x7F
	STS  _MidiProgramm,R30
; 0000 0040 		}
; 0000 0041 	}
_0x8:
_0x7:
; 0000 0042 }
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;// USART Transmitter interrupt service routine
;interrupt [USART_TXC] void usart_tx_isr(void)
; 0000 0046 {
_usart_tx_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0047 	UCSRB &= ~0x40;
	CBI  0xA,6
; 0000 0048 	TIFR = 0x20;	// Clear ICF1
	LDI  R30,LOW(32)
	OUT  0x38,R30
; 0000 0049 	TIMSK |= 0x20;	// On TICIE1
	IN   R30,0x39
	ORI  R30,0x20
	OUT  0x39,R30
; 0000 004A }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 004E {	// 2 mS @ 8MHz
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 004F 	if (DelayValue != 0)
	TST  R8
	BREQ _0x9
; 0000 0050 		DelayValue--;
	DEC  R8
; 0000 0051 	if (Ms10Tmr != 0)
_0x9:
	TST  R5
	BREQ _0xA
; 0000 0052 		Ms10Tmr--;
	DEC  R5
; 0000 0053 	else
	RJMP _0xB
_0xA:
; 0000 0054 	{	// 10 mS @ 8MHz
; 0000 0055 		Ms10Tmr = 4;
	LDI  R30,LOW(4)
	MOV  R5,R30
; 0000 0056 		FrontSwitchMajority[1] = FrontSwitchMajority[2];
	__GETB1MN _FrontSwitchMajority,2
	__PUTB1MN _FrontSwitchMajority,1
; 0000 0057 		FrontSwitchMajority[2] = FrontSwitchMajority[3];
	__GETB1MN _FrontSwitchMajority,3
	__PUTB1MN _FrontSwitchMajority,2
; 0000 0058 		FrontSwitchMajority[3] = (PINC & 0x3F) ^ 0x3F;
	IN   R30,0x13
	ANDI R30,LOW(0x3F)
	LDI  R26,LOW(63)
	EOR  R30,R26
	__PUTB1MN _FrontSwitchMajority,3
; 0000 0059 		FrontSwitchMajority[0] = ((FrontSwitchMajority[2] | FrontSwitchMajority[3]) & FrontSwitchMajority[1])
; 0000 005A 			| (FrontSwitchMajority[2] & FrontSwitchMajority[3]);
	__GETB2MN _FrontSwitchMajority,2
	__GETB1MN _FrontSwitchMajority,3
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _FrontSwitchMajority,1
	AND  R30,R26
	MOV  R0,R30
	__GETB2MN _FrontSwitchMajority,2
	__GETB1MN _FrontSwitchMajority,3
	AND  R30,R26
	OR   R30,R0
	STS  _FrontSwitchMajority,R30
; 0000 005B 		MidiChannel = (PIND >> 4) ^ 0x0F;
	IN   R30,0x10
	SWAP R30
	ANDI R30,0xF
	LDI  R26,LOW(15)
	EOR  R30,R26
	STS  _MidiChannel,R30
; 0000 005C 		if (SecTmr != 0)
	TST  R11
	BREQ _0xC
; 0000 005D 			SecTmr--;
	DEC  R11
; 0000 005E 		else
	RJMP _0xD
_0xC:
; 0000 005F 		{
; 0000 0060 			SecTmr = 99;
	LDI  R30,LOW(99)
	MOV  R11,R30
; 0000 0061 			if (PowUpTmr < 254)
	LDI  R30,LOW(254)
	CP   R10,R30
	BRSH _0xE
; 0000 0062 				PowUpTmr++;
	INC  R10
; 0000 0063 		}
_0xE:
_0xD:
; 0000 0064 		TimFlg = 1;
	SET
	BLD  R2,0
; 0000 0065 	}
_0xB:
; 0000 0066 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;//TIMSK/TIFR
;//Bit 5  TICIE1
;//Bit 4  OCIE1A
;// Timer 1 input capture interrupt service routine
;interrupt [TIM1_CAPT] void timer1_capt_isr(void)
; 0000 006C {
_timer1_capt_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 006D 	OCR1A = ICR1 + 384;
	IN   R30,0x26
	IN   R31,0x26+1
	SUBI R30,LOW(-384)
	SBCI R31,HIGH(-384)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 006E 	BitCnt = 0;
	CLR  R13
; 0000 006F 	TIMSK &= ~0x20;	// Off TICIE1
	IN   R30,0x39
	ANDI R30,0xDF
	OUT  0x39,R30
; 0000 0070 	TIFR = 0x10;	// Clear OCF1A
	LDI  R30,LOW(16)
	OUT  0x38,R30
; 0000 0071 	TIMSK |= 0x10;	// On OCIE1A
	IN   R30,0x39
	ORI  R30,0x10
	OUT  0x39,R30
; 0000 0072 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;// Timer 1 output compare A interrupt service routine
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 0076 {
_timer1_compa_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0077 	OCR1A += 256;
	IN   R30,0x2A
	IN   R31,0x2A+1
	SUBI R30,LOW(-256)
	SBCI R31,HIGH(-256)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 0078 	BitCnt++;
	INC  R13
; 0000 0079 	if (BitCnt < 9)
	LDI  R30,LOW(9)
	CP   R13,R30
	BRSH _0xF
; 0000 007A 	{
; 0000 007B 		RecByteI = RecByteI >> 1;
	LSR  R12
; 0000 007C 		if ((PINB & 0x01) != 0)
	SBIS 0x16,0
	RJMP _0x10
; 0000 007D 			RecByteI |= 0x80;
	LDI  R30,LOW(128)
	OR   R12,R30
; 0000 007E 	}
_0x10:
; 0000 007F 	else
	RJMP _0x11
_0xF:
; 0000 0080 	{
; 0000 0081 		TIFR = 0x20;	// Clear ICF1
	LDI  R30,LOW(32)
	OUT  0x38,R30
; 0000 0082 		TIMSK |= 0x20;	// On TICIE1
	IN   R30,0x39
	ORI  R30,0x20
	OUT  0x39,R30
; 0000 0083 		TIMSK &= ~0x10;	// Off OCIE1A
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
; 0000 0084 		RecByte = RecByteI;
	STS  _RecByte,R12
; 0000 0085 		DataReceived = 1;
	SET
	BLD  R2,3
; 0000 0086 	}
_0x11:
; 0000 0087 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;unsigned char
;EEPROM_read(unsigned short Address)
; 0000 008B {
_EEPROM_read:
; 0000 008C 	while(EECR & 0x02)	// Wait for completion of previous write
;	Address -> Y+0
_0x12:
	SBIC 0x1C,1
; 0000 008D 		;
	RJMP _0x12
; 0000 008E 	EEAR = Address;	// Set up address register
	LD   R30,Y
	LDD  R31,Y+1
	OUT  0x1E+1,R31
	OUT  0x1E,R30
; 0000 008F 	EECR |= 0x01;	// Start eeprom read by writing EERE
	SBI  0x1C,0
; 0000 0090 	return EEDR;	// Return data from data register
	IN   R30,0x1D
	ADIW R28,2
	RET
; 0000 0091 }
;
;void
;EEPROM_write(unsigned short Address, unsigned char Data)
; 0000 0095 {
_EEPROM_write:
; 0000 0096 	if (EEPROM_read(Address) == Data)
;	Address -> Y+1
;	Data -> Y+0
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _EEPROM_read
	MOV  R26,R30
	LD   R30,Y
	CP   R30,R26
	BREQ _0x2000002
; 0000 0097 	{
; 0000 0098 //		NextEeProgReq = 1;
; 0000 0099 		return;
; 0000 009A 	}
; 0000 009B 	EEAR = Address;	// Set up address and data registers
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x1E+1,R31
	OUT  0x1E,R30
; 0000 009C 	EEDR = Data;
	LD   R30,Y
	OUT  0x1D,R30
; 0000 009D 	#asm("cli")
	cli
; 0000 009E 	EECR |= 0x04;	// Write logical one to EEMWE
	SBI  0x1C,2
; 0000 009F 	EECR |= 0x0A;	// Start eeprom write by setting EEWE
	IN   R30,0x1C
	ORI  R30,LOW(0xA)
	OUT  0x1C,R30
; 0000 00A0 	#asm("sei")
	sei
; 0000 00A1 }
_0x2000002:
	ADIW R28,3
	RET
;
;void
;Wdog(void)
; 0000 00A5 {
_Wdog:
; 0000 00A6 	#asm("wdr")
	wdr
; 0000 00A7 }
	RET
;
;void
;Waitms(unsigned char Del)
; 0000 00AB {
_Waitms:
; 0000 00AC 	DelayValue = Del;
;	Del -> Y+0
	LDD  R8,Y+0
; 0000 00AD 	while (DelayValue != 0)
_0x16:
	TST  R8
	BREQ _0x18
; 0000 00AE 	{
; 0000 00AF 		Wdog();
	RCALL _Wdog
; 0000 00B0 	}
	RJMP _0x16
_0x18:
; 0000 00B1 }
	ADIW R28,1
	RET
;
;void
;SetHwRelays(void)
; 0000 00B5 {
_SetHwRelays:
; 0000 00B6 
; 0000 00B7 	HwRelayState = RelayState | 0x01;
	MOV  R30,R4
	ORI  R30,1
	MOV  R7,R30
; 0000 00B8 	if (PowUpTmr > 10)
	LDI  R30,LOW(10)
	CP   R30,R10
	BRSH _0x19
; 0000 00B9 		HwRelayState |= OUT6;
	LDI  R30,LOW(128)
	OR   R7,R30
; 0000 00BA 	if (PowUpTmr > 15)
_0x19:
	LDI  R30,LOW(15)
	CP   R30,R10
	BRSH _0x1A
; 0000 00BB 		HwRelayState |= OUT7;
	LDI  R30,LOW(64)
	OR   R7,R30
; 0000 00BC 	PORTB = HwRelayState;
_0x1A:
	OUT  0x18,R7
; 0000 00BD }
	RET
;void
;SetRelays(void)
; 0000 00C0 {
_SetRelays:
; 0000 00C1 	SetHwRelays();
	RCALL _SetHwRelays
; 0000 00C2 	UCSRA = 0x40;
	LDI  R30,LOW(64)
	OUT  0xB,R30
; 0000 00C3 	UCSRB |= 0x40;
	SBI  0xA,6
; 0000 00C4 	TIMSK &= ~0x20;	// off TICIE1
	IN   R30,0x39
	ANDI R30,0xDF
	OUT  0x39,R30
; 0000 00C5 	TIMSK &= ~0x10;	// Off OCIE1A
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
; 0000 00C6 	UDR = HwRelayState;
	OUT  0xC,R7
; 0000 00C7 }
	RET
;
;void
;SetOut1(void)
; 0000 00CB {
_SetOut1:
; 0000 00CC 	RelayState |= OUT1;
	LDI  R30,LOW(32)
	OR   R4,R30
; 0000 00CD 	SetHwRelays();
	RCALL _SetHwRelays
; 0000 00CE 	Waitms(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _Waitms
; 0000 00CF 	RelayState &= ~(OUT2 | OUT3 | OUT4);
	LDI  R30,LOW(227)
	AND  R4,R30
; 0000 00D0 	SetRelays();
	RJMP _0x2000001
; 0000 00D1 	SwitchSettingsAltered = 1;
; 0000 00D2 }
;
;void
;SetOut2(void)
; 0000 00D6 {
_SetOut2:
; 0000 00D7 	RelayState |= OUT2;
	LDI  R30,LOW(16)
	OR   R4,R30
; 0000 00D8 	SetHwRelays();
	RCALL _SetHwRelays
; 0000 00D9 	Waitms(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _Waitms
; 0000 00DA 	RelayState &= ~(OUT1 | OUT3 | OUT4);
	LDI  R30,LOW(211)
	AND  R4,R30
; 0000 00DB 	SetRelays();
	RJMP _0x2000001
; 0000 00DC 	SwitchSettingsAltered = 1;
; 0000 00DD }
;
;void
;SetOut3(void)
; 0000 00E1 {
_SetOut3:
; 0000 00E2 	RelayState |= OUT3;
	LDI  R30,LOW(8)
	OR   R4,R30
; 0000 00E3 	SetHwRelays();
	RCALL _SetHwRelays
; 0000 00E4 	Waitms(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _Waitms
; 0000 00E5 	RelayState &= ~(OUT1 | OUT2 | OUT4);
	LDI  R30,LOW(203)
	AND  R4,R30
; 0000 00E6 	SetRelays();
	RJMP _0x2000001
; 0000 00E7 	SwitchSettingsAltered = 1;
; 0000 00E8 }
;
;void
;SetOut4(void)
; 0000 00EC {
_SetOut4:
; 0000 00ED 	RelayState |= OUT4;
	LDI  R30,LOW(4)
	OR   R4,R30
; 0000 00EE 	SetHwRelays();
	RCALL _SetHwRelays
; 0000 00EF 	Waitms(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _Waitms
; 0000 00F0 	RelayState &= ~(OUT1 | OUT2 | OUT3);
	LDI  R30,LOW(199)
	AND  R4,R30
; 0000 00F1 	SetRelays();
	RJMP _0x2000001
; 0000 00F2 	SwitchSettingsAltered = 1;
; 0000 00F3 }
;
;void
;SetOut5(void)
; 0000 00F7 {
_SetOut5:
; 0000 00F8 	RelayState ^= OUT5;
	LDI  R30,LOW(2)
	EOR  R4,R30
; 0000 00F9 	SetRelays();
_0x2000001:
	RCALL _SetRelays
; 0000 00FA 	SwitchSettingsAltered = 1;
	SET
	BLD  R2,2
; 0000 00FB }
	RET
;
;void
;main(void)
; 0000 00FF {
_main:
; 0000 0100 	unsigned char	EeValue;
; 0000 0101 
; 0000 0102 	InitHw();
;	EeValue -> R17
	RCALL _InitHw
; 0000 0103 	TIFR = 0x20;	// Clear ICF1
	LDI  R30,LOW(32)
	OUT  0x38,R30
; 0000 0104 	TIMSK |= 0x20;	// On TICIE1
	IN   R30,0x39
	ORI  R30,0x20
	OUT  0x39,R30
; 0000 0105 	TIMSK &= ~0x10;	// Off OCIE1A
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
; 0000 0106 	PowUpTmr = 0;
	CLR  R10
; 0000 0107 	MidiProgramm = 255;
	LDI  R30,LOW(255)
	STS  _MidiProgramm,R30
; 0000 0108 	RelayState = OUT1;
	LDI  R30,LOW(32)
	MOV  R4,R30
; 0000 0109 	// Global enable interrupts
; 0000 010A 	#asm("sei")
	sei
; 0000 010B 	SetRelays();
	RCALL _SetRelays
; 0000 010C 	//
; 0000 010D 	while (1)
_0x1B:
; 0000 010E 	{
; 0000 010F 		Wdog();
	RCALL _Wdog
; 0000 0110 		if (TimFlg == 1)
	SBRS R2,0
	RJMP _0x1E
; 0000 0111 		{
; 0000 0112 			TimFlg = 0;
	CLT
	BLD  R2,0
; 0000 0113 			SetHwRelays();
	RCALL _SetHwRelays
; 0000 0114 			PrevFrontSwitchState = FrontSwitchState;
	MOV  R9,R6
; 0000 0115 			FrontSwitchState = FrontSwitchMajority[0];
	LDS  R6,_FrontSwitchMajority
; 0000 0116 			if (((FrontSwitchState & IN1) != 0) &&
; 0000 0117 				((PrevFrontSwitchState & IN1) == 0))
	SBRS R6,0
	RJMP _0x20
	SBRS R9,0
	RJMP _0x21
_0x20:
	RJMP _0x1F
_0x21:
; 0000 0118 			{
; 0000 0119 				SetOut1();
	RCALL _SetOut1
; 0000 011A 			}
; 0000 011B 			if (((FrontSwitchState & IN2) != 0) &&
_0x1F:
; 0000 011C 				((PrevFrontSwitchState & IN2) == 0))
	SBRS R6,1
	RJMP _0x23
	SBRS R9,1
	RJMP _0x24
_0x23:
	RJMP _0x22
_0x24:
; 0000 011D 			{
; 0000 011E 				SetOut2();
	RCALL _SetOut2
; 0000 011F 			}
; 0000 0120 			if (((FrontSwitchState & IN3) != 0) &&
_0x22:
; 0000 0121 				((PrevFrontSwitchState & IN3) == 0))
	SBRS R6,2
	RJMP _0x26
	SBRS R9,2
	RJMP _0x27
_0x26:
	RJMP _0x25
_0x27:
; 0000 0122 			{
; 0000 0123 				SetOut3();
	RCALL _SetOut3
; 0000 0124 			}
; 0000 0125 			if (((FrontSwitchState & IN4) != 0) &&
_0x25:
; 0000 0126 				((PrevFrontSwitchState & IN4) == 0))
	SBRS R6,3
	RJMP _0x29
	SBRS R9,3
	RJMP _0x2A
_0x29:
	RJMP _0x28
_0x2A:
; 0000 0127 			{
; 0000 0128 				SetOut4();
	RCALL _SetOut4
; 0000 0129 			}
; 0000 012A 			if (((FrontSwitchState & IN5) != 0) &&
_0x28:
; 0000 012B 				((PrevFrontSwitchState & IN5) == 0))
	SBRS R6,4
	RJMP _0x2C
	SBRS R9,4
	RJMP _0x2D
_0x2C:
	RJMP _0x2B
_0x2D:
; 0000 012C 			{
; 0000 012D 				SetOut5();
	RCALL _SetOut5
; 0000 012E 			}
; 0000 012F 		}
_0x2B:
; 0000 0130 		if (DataReceived)
_0x1E:
	SBRS R2,3
	RJMP _0x2E
; 0000 0131 		{
; 0000 0132 			DataReceived = 0;
	CLT
	BLD  R2,3
; 0000 0133 			if ((RecByte & IN1) != 0)
	LDS  R30,_RecByte
	ANDI R30,LOW(0x1)
	BREQ _0x2F
; 0000 0134 				SetOut1();
	RCALL _SetOut1
; 0000 0135 			if ((RecByte & IN2) != 0)
_0x2F:
	LDS  R30,_RecByte
	ANDI R30,LOW(0x2)
	BREQ _0x30
; 0000 0136 				SetOut2();
	RCALL _SetOut2
; 0000 0137 			if ((RecByte & IN3) != 0)
_0x30:
	LDS  R30,_RecByte
	ANDI R30,LOW(0x4)
	BREQ _0x31
; 0000 0138 				SetOut3();
	RCALL _SetOut3
; 0000 0139 			if ((RecByte & IN4) != 0)
_0x31:
	LDS  R30,_RecByte
	ANDI R30,LOW(0x8)
	BREQ _0x32
; 0000 013A 				SetOut4();
	RCALL _SetOut4
; 0000 013B 			if ((RecByte & IN5) != 0)
_0x32:
	LDS  R30,_RecByte
	ANDI R30,LOW(0x10)
	BREQ _0x33
; 0000 013C 				SetOut5();
	RCALL _SetOut5
; 0000 013D 		}
_0x33:
; 0000 013E 		if (MidiProgramm != 255)
_0x2E:
	LDS  R26,_MidiProgramm
	CPI  R26,LOW(0xFF)
	BREQ _0x34
; 0000 013F 		{
; 0000 0140 			if (MidiProgramm == LastReceivedProgramm &&
; 0000 0141 				 SwitchSettingsAltered != 0)
	LDS  R30,_LastReceivedProgramm
	CP   R30,R26
	BRNE _0x36
	LDI  R26,0
	SBRC R2,2
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x37
_0x36:
	RJMP _0x35
_0x37:
; 0000 0142 			{
; 0000 0143 				if ((FrontSwitchState & IN6) == 0/*!= 0*/)
	SBRC R6,5
	RJMP _0x38
; 0000 0144 					EEPROM_write(MidiProgramm, RelayState);
	LDS  R30,_MidiProgramm
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R4
	RCALL _EEPROM_write
; 0000 0145 			}
_0x38:
; 0000 0146 			else
	RJMP _0x39
_0x35:
; 0000 0147 			{
; 0000 0148 				EeValue =  EEPROM_read(MidiProgramm);
	LDS  R30,_MidiProgramm
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _EEPROM_read
	MOV  R17,R30
; 0000 0149 				if ((EeValue & ~(OUT1 | OUT2 | OUT3 | OUT4 | OUT5)) == 0)
	MOV  R30,R17
	ANDI R30,LOW(0xC1)
	BRNE _0x3A
; 0000 014A 				{
; 0000 014B 					RelayState = EeValue;
	MOV  R4,R17
; 0000 014C 					SetRelays();
	RCALL _SetRelays
; 0000 014D 				}
; 0000 014E 			}
_0x3A:
_0x39:
; 0000 014F 			LastReceivedProgramm = MidiProgramm;
	LDS  R30,_MidiProgramm
	STS  _LastReceivedProgramm,R30
; 0000 0150 			SwitchSettingsAltered = 0;
	CLT
	BLD  R2,2
; 0000 0151 			MidiProgramm = 255;
	LDI  R30,LOW(255)
	STS  _MidiProgramm,R30
; 0000 0152 		}
; 0000 0153 	}
_0x34:
	RJMP _0x1B
; 0000 0154 }
_0x3B:
	RJMP _0x3B
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;void
;InitHw(void)
; 0001 0005 {

	.CSEG
_InitHw:
; 0001 0006 	// Input/Output Ports initialization
; 0001 0007 	// Port B initialization
; 0001 0008 	// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
; 0001 0009 	// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=P
; 0001 000A 	PORTB = 0x01;
	LDI  R30,LOW(1)
	OUT  0x18,R30
; 0001 000B 	DDRB = 0xFE;
	LDI  R30,LOW(254)
	OUT  0x17,R30
; 0001 000C 	// Port C initialization
; 0001 000D 	// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0001 000E 	// State6=P State5=P State4=P State3=P State2=P State1=P State0=P
; 0001 000F 	PORTC = 0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
; 0001 0010 	DDRC = 0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0001 0011 	// Port D initialization
; 0001 0012 	// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=In
; 0001 0013 	// State7=P State6=P State5=P State4=P State3=1 State2=1 State1=1 State0=P
; 0001 0014 	PORTD = 0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
; 0001 0015 	DDRD = 0x0E;
	LDI  R30,LOW(14)
	OUT  0x11,R30
; 0001 0016 	// Timer/Counter 0 initialization
; 0001 0017 	// Clock source: System Clock
; 0001 0018 	// Clock value: 125,000 kHz
; 0001 0019 	TCCR0 = 0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0001 001A 	TCNT0 = 0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0001 001B 	// Timer/Counter 1 initialization
; 0001 001C 	// Clock source: System Clock
; 0001 001D 	// Clock value: 8000,000 kHz
; 0001 001E 	// Mode: Normal top=FFFFh
; 0001 001F 	// OC1A output: Discon.
; 0001 0020 	// OC1B output: Discon.
; 0001 0021 	// Noise Canceler: Off
; 0001 0022 	// Input Capture on Falling Edge
; 0001 0023 	// Timer 1 Overflow Interrupt: Off
; 0001 0024 	// Input Capture Interrupt: On
; 0001 0025 	// Compare A Match Interrupt: On
; 0001 0026 	// Compare B Match Interrupt: Off
; 0001 0027 	TCCR1A = 0x00;
	OUT  0x2F,R30
; 0001 0028 	TCCR1B = 0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
; 0001 0029 	TCNT1H = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0001 002A 	TCNT1L = 0x00;
	OUT  0x2C,R30
; 0001 002B 	ICR1H = 0x00;
	OUT  0x27,R30
; 0001 002C 	ICR1L = 0x00;
	OUT  0x26,R30
; 0001 002D 	OCR1AH = 0x00;
	OUT  0x2B,R30
; 0001 002E 	OCR1AL = 0x00;
	OUT  0x2A,R30
; 0001 002F 	OCR1BH = 0x00;
	OUT  0x29,R30
; 0001 0030 	OCR1BL = 0x00;
	OUT  0x28,R30
; 0001 0031 	// Timer/Counter 2 initialization
; 0001 0032 	// Clock source: System Clock
; 0001 0033 	// Clock value: Timer 2 Stopped
; 0001 0034 	// Mode: Normal top=FFh
; 0001 0035 	// OC2 output: Disconnected
; 0001 0036 	ASSR = 0x00;
	OUT  0x22,R30
; 0001 0037 	TCCR2 = 0x00;
	OUT  0x25,R30
; 0001 0038 	TCNT2 = 0x00;
	OUT  0x24,R30
; 0001 0039 	OCR2 = 0x00;
	OUT  0x23,R30
; 0001 003A 	// External Interrupt(s) initialization
; 0001 003B 	// INT0: Off
; 0001 003C 	// INT1: Off
; 0001 003D 	MCUCR = 0x00;
	OUT  0x35,R30
; 0001 003E 	// Timer(s)/Counter(s) Interrupt(s) initialization
; 0001 003F 	TIMSK=0x31;
	LDI  R30,LOW(49)
	OUT  0x39,R30
; 0001 0040 	// USART initialization
; 0001 0041 	// Communication Parameters: 8 Data, 1 Stop, No Parity
; 0001 0042 	// USART Receiver: On
; 0001 0043 	// USART Transmitter: On
; 0001 0044 	// USART Mode: Asynchronous
; 0001 0045 	// USART Baud rate: 31250
; 0001 0046 	UCSRA = 0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0001 0047 	UCSRB = 0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0001 0048 	UCSRC = 0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0001 0049 	UBRRH = 0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0001 004A 	UBRRL = 0x0F;
	LDI  R30,LOW(15)
	OUT  0x9,R30
; 0001 004B 	// Analog Comparator initialization
; 0001 004C 	// Analog Comparator: Off
; 0001 004D 	// Analog Comparator Input Capture by Timer/Counter 1: Off
; 0001 004E 	ACSR = 0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0001 004F 	SFIOR = 0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0001 0050 	// Watchdog Timer initialization
; 0001 0051 	// Watchdog Timer Prescaler: OSC/2048k
; 0001 0052 #pragma optsize-
; 0001 0053 	WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0001 0054 	WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0001 0055 #ifdef _OPTIMIZE_SIZE_
; 0001 0056 #pragma optsize+
; 0001 0057 #endif
; 0001 0058 }
	RET

	.DSEG
_FrontSwitchMajority:
	.BYTE 0x4
_RecByte:
	.BYTE 0x1
_MidiChannel:
	.BYTE 0x1
_MidiProgramm:
	.BYTE 0x1
_LastReceivedProgramm:
	.BYTE 0x1

	.CSEG

	.CSEG
;END OF CODE MARKER
__END_OF_CODE:
