;CodeVisionAVR C Compiler V1.24.6 Standard
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Fs.vec"
	.INCLUDE "Fs.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Chip type           : ATmega8
;       3 Program type        : Application
;       4 Clock frequency     : 8,000000 MHz
;       5 Memory model        : Small
;       6 External SRAM size  : 0
;       7 Data Stack size     : 256
;       8 *****************************************************/
;       9 
;      10 #include	<mega8.h>
;      11 #include	"Hw.h"
;      12 
;      13 unsigned char	Ms10Tmr;
;      14 unsigned char	FrontSwitchMajority[4];
_FrontSwitchMajority:
	.BYTE 0x4
;      15 unsigned char	HwRelayState;
;      16 unsigned char	FrontSwitchState;
;      17 unsigned char	PrevFrontSwitchState;
;      18 //
;      19 unsigned char	BitCnt;
;      20 unsigned char	RecByteI;
;      21 unsigned char	RecByte;
;      22 //
;      23 
;      24 bit	TimFlg;
;      25 bit	DataReceived;
;      26 
;      27 // USART Receiver interrupt service routine
;      28 interrupt [USART_RXC] void usart_rx_isr(void)
;      29 {

	.CSEG
_usart_rx_isr:
;      30 	unsigned char	inByte;
;      31 
;      32 	inByte = UCSRA;
	ST   -Y,R16
;	inByte -> R16
	IN   R16,11
;      33 	inByte = UDR;
	IN   R16,12
;      34 }
	LD   R16,Y+
	RETI
;      35 
;      36 // USART Transmitter interrupt service routine
;      37 interrupt [USART_TXC] void usart_tx_isr(void)
;      38 {
_usart_tx_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      39 	UCSRB &= ~0x40;
	CBI  0xA,6
;      40 	TIFR = 0x20;	// Clear ICF1
	RCALL SUBOPT_0x0
;      41 	TIMSK |= 0x20;	// On TICIE1
;      42 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;      43 
;      44 // Timer 0 overflow interrupt service routine
;      45 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;      46 {	// 2 mS @ 8MHz
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      47 	if (Ms10Tmr != 0)
	TST  R4
	BREQ _0x3
;      48 		Ms10Tmr--;
	DEC  R4
;      49 	else
	RJMP _0x4
_0x3:
;      50 	{	// 10 mS @ 8MHz
;      51 		Ms10Tmr = 4;
	LDI  R30,LOW(4)
	MOV  R4,R30
;      52 		FrontSwitchMajority[1] = FrontSwitchMajority[2];
	__GETB1MN _FrontSwitchMajority,2
	__PUTB1MN _FrontSwitchMajority,1
;      53 		FrontSwitchMajority[2] = FrontSwitchMajority[3];
	__GETB1MN _FrontSwitchMajority,3
	__PUTB1MN _FrontSwitchMajority,2
;      54 		FrontSwitchMajority[3] = (PINC & 0x3F) ^ 0x3F;
	IN   R30,0x13
	ANDI R30,LOW(0x3F)
	LDI  R26,LOW(63)
	EOR  R30,R26
	__PUTB1MN _FrontSwitchMajority,3
;      55 		FrontSwitchMajority[0] = ((FrontSwitchMajority[2] | FrontSwitchMajority[3]) & FrontSwitchMajority[1])
;      56 			| (FrontSwitchMajority[2] & FrontSwitchMajority[3]);
	__GETB2MN _FrontSwitchMajority,2
	__GETB1MN _FrontSwitchMajority,3
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _FrontSwitchMajority,1
	AND  R30,R26
	PUSH R30
	__GETB2MN _FrontSwitchMajority,2
	__GETB1MN _FrontSwitchMajority,3
	AND  R30,R26
	POP  R26
	OR   R30,R26
	STS  _FrontSwitchMajority,R30
;      57 		TimFlg = 1;
	SET
	BLD  R2,0
;      58 	}
_0x4:
;      59 	if ((PINB & 0x01) != 0)
	SBIS 0x16,0
	RJMP _0x5
;      60 		PORTD |= 0x04;
	SBI  0x12,2
;      61 	else
	RJMP _0x6
_0x5:
;      62 		PORTD &= ~0x04;
	CBI  0x12,2
;      63 }
_0x6:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
;      64 //TIMSK/TIFR
;      65 //Bit 5  TICIE1
;      66 //Bit 4  OCIE1A
;      67 // Timer 1 input capture interrupt service routine
;      68 interrupt [TIM1_CAPT] void timer1_capt_isr(void)
;      69 {
_timer1_capt_isr:
	RCALL SUBOPT_0x1
;      70 	PORTD &= ~0x08;
	CBI  0x12,3
;      71 	OCR1A = ICR1 + 384;
	IN   R30,0x26
	IN   R31,0x26+1
	SUBI R30,LOW(-384)
	SBCI R31,HIGH(-384)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;      72 	BitCnt = 0;
	CLR  R8
;      73 	TIMSK &= ~0x20;	// Off TICIE1
	RCALL SUBOPT_0x2
;      74 	TIFR = 0x10;	// Clear OCF1A
	LDI  R30,LOW(16)
	OUT  0x38,R30
;      75 	TIMSK |= 0x10;	// On OCIE1A
	IN   R30,0x39
	ORI  R30,0x10
	OUT  0x39,R30
;      76 }
	RCALL SUBOPT_0x3
	RETI
;      77 
;      78 // Timer 1 output compare A interrupt service routine
;      79 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;      80 {
_timer1_compa_isr:
	RCALL SUBOPT_0x1
;      81 	OCR1A += 256;
	IN   R30,0x2A
	IN   R31,0x2A+1
	SUBI R30,LOW(-256)
	SBCI R31,HIGH(-256)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;      82 	BitCnt++;
	INC  R8
;      83 	if (BitCnt < 9)
	LDI  R30,LOW(9)
	CP   R8,R30
	BRSH _0x7
;      84 	{
;      85 		RecByteI = RecByteI >> 1;
	LSR  R9
;      86 		if ((PINB & 0x01) != 0)
	SBIS 0x16,0
	RJMP _0x8
;      87 			RecByteI |= 0x80;
	LDI  R30,LOW(128)
	OR   R9,R30
;      88 	}
_0x8:
;      89 	else
	RJMP _0x9
_0x7:
;      90 	{
;      91 		TIFR = 0x20;	// Clear ICF1
	RCALL SUBOPT_0x0
;      92 		TIMSK |= 0x20;	// On TICIE1
;      93 		TIMSK &= ~0x10;	// Off OCIE1A
	RCALL SUBOPT_0x4
;      94 		RecByte = RecByteI;
	MOV  R10,R9
;      95 		DataReceived = 1;
	SET
	BLD  R2,1
;      96 		PORTD |= 0x08;
	SBI  0x12,3
;      97 	}
_0x9:
;      98 }
	RCALL SUBOPT_0x3
	RETI
;      99 
;     100 void
;     101 Wdog(void)
;     102 {
_Wdog:
;     103 	#asm("wdr")
	wdr
;     104 }
	RET
;     105 
;     106 void
;     107 SetHwRelays(void)
;     108 {
_SetHwRelays:
;     109 	HwRelayState = RecByte | 0x01;
	MOV  R30,R10
	ORI  R30,1
	MOV  R5,R30
;     110 	PORTB = HwRelayState;
	OUT  0x18,R5
;     111 }
	RET
;     112 
;     113 void
;     114 SendIn(unsigned char Val)
;     115 {
_SendIn:
;     116 	UCSRA = 0x40;
	LDI  R30,LOW(64)
	OUT  0xB,R30
;     117 	UCSRB |= 0x40;
	SBI  0xA,6
;     118 	TIMSK &= ~0x20;	// off TICIE1
	RCALL SUBOPT_0x2
;     119 	TIMSK &= ~0x10;	// Off OCIE1A
	RCALL SUBOPT_0x4
;     120 	UDR = Val;
	LD   R30,Y
	OUT  0xC,R30
;     121 }
	ADIW R28,1
	RET
;     122 
;     123 void
;     124 main(void)
;     125 {
_main:
;     126 	InitHw();
	RCALL _InitHw
;     127 	TIFR = 0x20;	// Clear ICF1
	RCALL SUBOPT_0x0
;     128 	TIMSK |= 0x20;	// On TICIE1
;     129 	TIMSK &= ~0x10;	// Off OCIE1A
	RCALL SUBOPT_0x4
;     130 	// Global enable interrupts
;     131 	#asm("sei")
	sei
;     132 	while (1)
_0xA:
;     133 	{
;     134 		Wdog();
	RCALL _Wdog
;     135 		if (TimFlg == 1)
	SBRS R2,0
	RJMP _0xD
;     136 		{
;     137 			TimFlg = 0;
	CLT
	BLD  R2,0
;     138 			PrevFrontSwitchState = FrontSwitchState;
	MOV  R7,R6
;     139 			FrontSwitchState = FrontSwitchMajority[0];
	LDS  R6,_FrontSwitchMajority
;     140 			if (((FrontSwitchState & IN1) != 0) &&
;     141 				((PrevFrontSwitchState & IN1) == 0))
	SBRS R6,0
	RJMP _0xF
	SBRS R7,0
	RJMP _0x10
_0xF:
	RJMP _0xE
_0x10:
;     142 			{
;     143 				SendIn(IN1);
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x5
;     144 			}
;     145 			if (((FrontSwitchState & IN2) != 0) &&
_0xE:
;     146 				((PrevFrontSwitchState & IN2) == 0))
	SBRS R6,1
	RJMP _0x12
	SBRS R7,1
	RJMP _0x13
_0x12:
	RJMP _0x11
_0x13:
;     147 			{
;     148 				SendIn(IN2);
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x5
;     149 			}
;     150 			if (((FrontSwitchState & IN3) != 0) &&
_0x11:
;     151 				((PrevFrontSwitchState & IN3) == 0))
	SBRS R6,2
	RJMP _0x15
	SBRS R7,2
	RJMP _0x16
_0x15:
	RJMP _0x14
_0x16:
;     152 			{
;     153 				SendIn(IN3);
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x5
;     154 			}
;     155 			if (((FrontSwitchState & IN4) != 0) &&
_0x14:
;     156 				((PrevFrontSwitchState & IN4) == 0))
	SBRS R6,3
	RJMP _0x18
	SBRS R7,3
	RJMP _0x19
_0x18:
	RJMP _0x17
_0x19:
;     157 			{
;     158 				SendIn(IN4);
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x5
;     159 			}
;     160 			if (((FrontSwitchState & IN5) != 0) &&
_0x17:
;     161 				((PrevFrontSwitchState & IN5) == 0))
	SBRS R6,4
	RJMP _0x1B
	SBRS R7,4
	RJMP _0x1C
_0x1B:
	RJMP _0x1A
_0x1C:
;     162 			{
;     163 				SendIn(IN5);
	LDI  R30,LOW(16)
	RCALL SUBOPT_0x5
;     164 			}
;     165 		}
_0x1A:
;     166 		if (DataReceived)
_0xD:
	SBRS R2,1
	RJMP _0x1D
;     167 		{
;     168 			DataReceived = 0;
	CLT
	BLD  R2,1
;     169 			SetHwRelays();
	RCALL _SetHwRelays
;     170 		}
;     171 	}
_0x1D:
	RJMP _0xA
;     172 }
_0x1E:
	RJMP _0x1E
;     173 #include <mega8.h>
;     174 
;     175 void
;     176 InitHw(void)
;     177 {
_InitHw:
;     178 	// Input/Output Ports initialization
;     179 	// Port B initialization
;     180 	// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In 
;     181 	// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=P 
;     182 	PORTB = 0x01;
	LDI  R30,LOW(1)
	OUT  0x18,R30
;     183 	DDRB = 0xFE;
	LDI  R30,LOW(254)
	OUT  0x17,R30
;     184 	// Port C initialization
;     185 	// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     186 	// State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
;     187 	PORTC = 0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     188 	DDRC = 0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
;     189 	// Port D initialization
;     190 	// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
;     191 	// State7=P State6=P State5=P State4=P State3=1 State2=1 State1=1 State0=P 
;     192 	PORTD = 0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     193 	DDRD = 0x0E;
	LDI  R30,LOW(14)
	OUT  0x11,R30
;     194 	// Timer/Counter 0 initialization
;     195 	// Clock source: System Clock
;     196 	// Clock value: 125,000 kHz
;     197 	TCCR0 = 0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     198 	TCNT0 = 0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     199 	// Timer/Counter 1 initialization
;     200 	// Clock source: System Clock
;     201 	// Clock value: 8000,000 kHz
;     202 	// Mode: Normal top=FFFFh
;     203 	// OC1A output: Discon.
;     204 	// OC1B output: Discon.
;     205 	// Noise Canceler: Off
;     206 	// Input Capture on Falling Edge
;     207 	// Timer 1 Overflow Interrupt: Off
;     208 	// Input Capture Interrupt: On
;     209 	// Compare A Match Interrupt: On
;     210 	// Compare B Match Interrupt: Off
;     211 	TCCR1A = 0x00;
	OUT  0x2F,R30
;     212 	TCCR1B = 0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
;     213 	TCNT1H = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     214 	TCNT1L = 0x00;
	OUT  0x2C,R30
;     215 	ICR1H = 0x00;
	OUT  0x27,R30
;     216 	ICR1L = 0x00;
	OUT  0x26,R30
;     217 	OCR1AH = 0x00;
	OUT  0x2B,R30
;     218 	OCR1AL = 0x00;
	OUT  0x2A,R30
;     219 	OCR1BH = 0x00;
	OUT  0x29,R30
;     220 	OCR1BL = 0x00;
	OUT  0x28,R30
;     221 	// Timer/Counter 2 initialization
;     222 	// Clock source: System Clock
;     223 	// Clock value: Timer 2 Stopped
;     224 	// Mode: Normal top=FFh
;     225 	// OC2 output: Disconnected
;     226 	ASSR = 0x00;
	OUT  0x22,R30
;     227 	TCCR2 = 0x00;
	OUT  0x25,R30
;     228 	TCNT2 = 0x00;
	OUT  0x24,R30
;     229 	OCR2 = 0x00;
	OUT  0x23,R30
;     230 	// External Interrupt(s) initialization
;     231 	// INT0: Off
;     232 	// INT1: Off
;     233 	MCUCR = 0x00;
	OUT  0x35,R30
;     234 	// Timer(s)/Counter(s) Interrupt(s) initialization
;     235 	TIMSK=0x31;
	LDI  R30,LOW(49)
	OUT  0x39,R30
;     236 	// USART initialization
;     237 	// Communication Parameters: 8 Data, 1 Stop, No Parity
;     238 	// USART Receiver: On
;     239 	// USART Transmitter: On
;     240 	// USART Mode: Asynchronous
;     241 	// USART Baud rate: 31250
;     242 	UCSRA = 0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     243 	UCSRB = 0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     244 	UCSRC = 0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     245 	UBRRH = 0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     246 	UBRRL = 0x0F;
	LDI  R30,LOW(15)
	OUT  0x9,R30
;     247 	// Analog Comparator initialization
;     248 	// Analog Comparator: Off
;     249 	// Analog Comparator Input Capture by Timer/Counter 1: Off
;     250 	ACSR = 0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     251 	SFIOR = 0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     252 	// Watchdog Timer initialization
;     253 	// Watchdog Timer Prescaler: OSC/2048k
;     254 #pragma optsize-
;     255 	WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
;     256 	WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
;     257 #ifdef _OPTIMIZE_SIZE_
;     258 #pragma optsize+
;     259 #endif
;     260 }
	RET


;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(32)
	OUT  0x38,R30
	IN   R30,0x39
	ORI  R30,0x20
	OUT  0x39,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	IN   R30,0x39
	ANDI R30,0xDF
	OUT  0x39,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4:
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	ST   -Y,R30
	RJMP _SendIn

;END OF CODE MARKER
__END_OF_CODE:
